<%
' --------------------------------------- WWW.DOMOTICAWORLD.COM ------------------------------------------
'           Based on script from Jim Steed http://board.homeseer.com/showthread.php?t=133718
'											Modified by DJF3
'v0.1  29-jun-2012 DJ: modified code (events ran in the last 24hrs are grey)
'v0.3  01-jul-2012 DJ: Added Group filter
'v0.4  03-jul-2012 DJ: Added Age filter
'v0.5  xx-jul-2012 DJ: Added DJ_CheckEvents.html that points to the latest version (don't have to update bookmarks)
'			Fixed date filtering (now using age field)
'v0.6  07-jul-2012 DJ: Updated lay-out (removed group column), added color for new group row
'v0.7  19-Mei-2013 DJ: added 1000-day option
'v0.7b  08-Nov-2013 DJ: NEED TO PUT IN NEW VERSION? replace age>40000 with 'unknown'
'
' ======================  MAKE  database
sub MakeDB()
    Const adVarChar = 200
    Const adInteger = 3
    Const adDate = 7

    With evdb.fields
        .Append "Group", adVarChar, 200
        .Append "Name", adVarChar, 200
        .Append "Date", adVarChar, 50
        .Append "Elapsed", adVarChar, 50
		'DJ: test for sorting
		.Append "Age", adInteger
        .Append "RefId", adVarChar, 50
    End With
end sub
' ======================  FILL  database
sub FillDB()
    set EventEnum = hs.GetEventEnumerator
    If EventEnum Is Nothing Then
        hs.WriteLog "Error", "Unable to get Event Enumerator"
    Else
		evdb.Open
        Do While Not EventEnum.Finished
			set EventDetails = EventEnum.GetNext
			q = ""
			q = datevalue(now) - datevalue(EventDetails.last_trigger_time)
			If (EventDetails.group = GroupFilter OR GroupFilter = "ALL") AND (q>=Cint(MinAge) OR MinAge=0) then 
				evdb.addnew
					x = ""
					x = datevalue(now) - datevalue(EventDetails.last_trigger_time)
				evdb.fields("Age") = x
				evdb.fields("Name") = EventDetails.Name
				evdb.fields("Group") = EventDetails.group
				evdb.fields("Date") = EventDetails.last_trigger_time
					if x = 0 then
						x = timevalue(now) - timevalue(EventDetails.last_trigger_time)
						x = round(x*24,1) & " hours"
					else
						x = x & " d"
					end if
				evdb.fields("Elapsed") = x
				evdb.fields("RefId") = EventDetails.evref
			End if
        Loop
		evdb.Sort = SortOrder

    end if
end sub
' ======================  SHOW  database
sub ShowDb()
    s.Add "<table bgcolor='#B6C8ED' color=#000000 width=""100%"">"
	'header row
    s.Add "<tr>"
		s.Add "<td class=tablecolumn align=center>Event Name</td>"
		s.Add "<td class=tablecolumn align=center>Date Last Ran</td>"
		s.Add "<td class=tablecolumn align=center>Elapsed</td>"
		s.Add "<td class=tablecolumn align=center>Ref Id</td>"
    s.Add "</tr>"
    if not (evdb.BOF AND evdb.EOF) then 
        evdb.movefirst 'showdb
    else
        s.Add "<td>No devices meet criteria</td>"
    end if
    Do while (not evdb.EOF )
		newGroup = evdb.fields("Group")
        If left(rowstyle,11) = rowstyleodd Then
			rowstyle = rowstyleeven
        Else
            rowstyle = rowstyleodd
		End If
		'DJ: Row below turns events <1 day gray (because these are not as relevant)
        If Instr(evdb.fields("Elapsed"),"h") > 0 then rowstyle = rowstyle & "Hr" 
		If newGroup <> oldGroup and Instr(SortOrder,"Group")>0 then 
			rowstyle = rowstyle
			s.Add "<tr><td colspan=4 class=" & rowstyle & "Bold" & "><a href='/evls?group=" & evdb.fields("Group") & "'>" & evdb.fields("Group") & "</a></td></tr>"
		End if
		s.Add "<tr>"
        s.Add "<td class=" & rowstyle & ">"
			s.Add "<a href=""/evnm" & evdb.fields("refid") & "&edit=1"" target=_edit><img src='button_edit_event.gif' style='border:0px;' /></a> "
			s.Add evdb.fields("Name")
		s.Add "<td class=" & rowstyle & ">" & evdb.fields("Date") & "&nbsp;</td>"
' ======== DJ 8-sep-2013 added code to display 'unknown' if age 41525 days
		If len(evdb.fields("Elapsed"))>6 then
			s.Add "<td align=center class=" & rowstyle & ">" & "<span style='color:#AAAAAA;'>unknown</span> &nbsp;</td>"
		else
			s.Add "<td align=center class=" & rowstyle & ">" & evdb.fields("Elapsed") & "&nbsp;</td>"
		end if
' ========
        s.Add "<td align=center class=" & rowstyle & ">"
			s.Add evdb.fields("refid") & "</a>"
        s.Add "</td>"
        s.Add "</tr>"
		oldGroup = newGroup
        evdb.movenext
    loop
    s.Add "</table>"
    Response.Write s.value 'table values
    s.reset
end sub
function IsSelected(phrase,sSort)
    if phrase = sSort then
        IsSelected = " selected "
    else
        IsSelected = ""
    end if
end function
function IsSelectedGr(phrase,fGroup)
    if phrase = fGroup then
        IsSelectedGr = " selected "
    else
        IsSelectedGr = ""
    end if
end function
function IsSelectedAge(phrase,aGroup)
    if phrase = aGroup then
        IsSelectedAge = " selected "
    else
        IsSelectedAge = ""
    end if
end function


'-------------------- Start execution HERE

'DJ: Create event GROUP listbox 
varVersion = "0.7b"
Dim arrListBox(1000)
ListboxCounter = 0
Set evenlist = hs.GetEventEnumerator
	Do Until evenlist.Finished
		set evl = evenlist.GetNext 
		If instr(strEventList,evl.Group) = 0 and evl.Group<>"" then
			arrListBox(ListboxCounter) = evl.Group
			strEventList = strEventList & "-" & evl.Group
			ListboxCounter = ListboxCounter + 1
		End if
	Loop
'DJ: Sort event GROUP list
For i=0 to ListboxCounter 
	For j=i+1 to ListboxCounter 
		If arrListBox(i)>arrListBox(j) then
			TemporalVariable=arrListBox(i)
			arrListBox(i)=arrListBox(j)
			arrListBox(j)=TemporalVariable
		End If
	Next 
Next  


'------------------------------ the official code:
set s = hs.CreateStringClass
Set evdb = CreateObject("ADODB.Recordset")

s.Add hs.GetPageHeader ("Device Extended View","","",False,False,False,False,False)	'v1.01 thanks Jon00
rowstyleodd = "tablerowodd"
rowstyleeven = "tableroweven"

if Request.Form("SortOrder") = "" then
	SortOrder = "Group,Age ASC,Name"
else
	SortOrder = request.form("sortorder")
end if
if Request.Form("GroupFilter") = "" then
	GroupFilter = "ALL"
else
	GroupFilter = request.form("GroupFilter")
end if
if Request.Form("MinAge") = "" then
	MinAge = "0"
else
	MinAge = request.form("MinAge")
end if


MakeDB()
FillDB()
'Group list
s.Add "<form>"
s.Add "<br>Group Filter:&nbsp;"
s.Add "<select class=formdropdown name=""GroupFilter"" >"
strEventList = "<option value=""ALL""" & IsSelectedGr("ALL", GroupFilter)& ">ALL</option>"
For i=1 to ListboxCounter
	strEventList = strEventList & "<option value='" & arrListBox(i)  & "'" & IsSelectedGr(arrListBox(i), GroupFilter)& ">" & arrListBox(i)  & "</option>"
Next
s.Add strEventList
s.Add "</select>&nbsp;&nbsp;&nbsp;&nbsp;"


'age choices
s.Add " Minimum Age:&nbsp;"
s.Add "<select class=formdropdown name=""MinAge"" >"
s.Add "<option value=""0""" & IsSelectedAge("0", MinAge)& ">ALL</option>"
s.Add "<option value=""1""" & IsSelectedAge("1", MinAge)& ">1</option>"
s.Add "<option value=""7""" & IsSelectedAge("7", MinAge)& ">7</option>"
s.Add "<option value=""30""" & IsSelectedAge("30", MinAge)& ">30</option>"
s.Add "<option value=""90""" & IsSelectedAge("90", MinAge)& ">90</option>"
s.Add "<option value=""180""" & IsSelectedAge("180", MinAge)& ">180</option>"
s.Add "<option value=""365""" & IsSelectedAge("365", MinAge)& ">365</option>"
s.Add "<option value=""1000""" & IsSelectedAge("1000", MinAge)& ">1000</option>"
s.Add "</select>&nbsp;&nbsp;&nbsp;&nbsp;"

'sorting choices
s.Add " Sort By:&nbsp;"
s.Add "<select class=formdropdown name=""SortOrder"" >"
s.Add "<option value=""Age ASC""" & IsSelected("Age ASC", SortOrder)& ">Age ASC</option>"
s.Add "<option value=""Age DESC""" & IsSelected("Age DESC", SortOrder)& ">Age DESC</option>"
s.Add "<option value=""Name ASC""" & IsSelected("Name ASC", SortOrder)& ">Name ASC</option>"
s.Add "<option value=""Name DESC""" & IsSelected("Name DESC", SortOrder)& ">Name DESC</option>"
s.Add "<option value=""Group,Name,Age""" & IsSelected("Group,Name,Age", SortOrder)& ">Group Name Date</option>"
s.Add "<option value=""Group,Age DESC,Name""" & IsSelected("Group,Age DESC,Name", SortOrder)& ">Group Age-Desc Name</option>"
s.Add "<option value=""Group,Age ASC,Name""" & IsSelected("Group,Age ASC,Name", SortOrder)& ">Group Age-Asc Name</option>"
s.Add "</select>&nbsp;&nbsp;&nbsp;&nbsp;"
s.Add "<input type=""submit"" value=""Filter"" >"
s.Add "&nbsp;&nbsp;&nbsp;&nbsp; " & evdb.RecordCount & " of " & hs.EventCount & " events"
s.Add "&nbsp;&nbsp;&nbsp;&nbsp; <span style='color:#CCCCCC;'>v " & varVersion & "</span>"
s.Add "</form>"

showdb()
Response.Write s.value 'table values
s.reset
'============
if usingOpera then
	response.write "<br>"
else
    response.write hs.GetPageFooter (FALSE)
end if
	
%>

<style type="text/css">
td {
	padding-left : 3px;
	padding-right : 3px;
	font-family : Verdana, Arial, sans-serif;
	font-size : 8pt;
}
.tablerowevenHr {
	background: #EFEFEF;
	color: #747474;
}
.tablerowoddHr {
	background: #DFDFDF;
	color: #747474;
}
.tablerowevenHrBold {
	background: #CCFFFF;
	color: #747474;
	font-weight: bold;
}
.tablerowoddHrBold {
	background: #CCFFFF;
	color: #747474;
	font-weight: bold;
}
.tablerowevenBold {
	background: #CCFFFF;
	font-weight: bold;
}
.tablerowoddBold {
	background: #CCFFFF;
	font-weight: bold;
}

</style>
